/***************************************************************/
/*                                                             */
/*     VAR analysis: compute marginal data density             */
/*                                                             */
/*                                                             */
/*            Frank Schorfheide , Taeyoung Doh                 */
/***************************************************************/

/* Filename:  vardd.g
** created:   11/12/98
*   modifieed : 02/27/05 
*/

new;
closeall;
cls;
library pgraph;

_FIX1 = 0;
_FIX2 = 0;
__output = 0;

/* Import data on output and hours
** dummy observations and 
** observations from 1960:I to 1997:IV :sample 
*/

#include vardummy.g

T1     = rows(y1);
nvar   = nv;
p      = nlag;                  /* number of lags                       */
k      = 1 + nvar*p;            /* number of coefficients per equation  */

T0 = rows(y0);

y0~x0;

/* Compute OLS estimates
*/
nobs=T0+T1; 
XX=x0'x0+x1'x1; 
XXY=x0'y0+x1'y1; 
YY=y0'y0+y1'y1; 
CC_hat  = inv(XX)*XXY; 
C_hat   = vec(CC_hat);
SIG_hat = (YY-XXY'CC_hat)/nobs; tCC_hat=CC_hat';
CC_stack= tCC_hat[.,1:nvar*p] |(eye(nvar*(p-1)) ~ zeros(nvar*(p-1),nvar));
{test1,test2}=eigv(CC_stack); test3=sorthc(abs(test1),1); 
"posterior mean of coefficients"; C_hat[1:k,.]'; C_hat[k+1:2*k,.]'; 
"largest eigenvalue" test3[rows(test3),1];; "second largest eigenvalue" test3[rows(test3)-1,1];
SIG_phi=(SIG_hat.*.inv(XX));
dia=sqrt(diag(SIG_phi)); 
"standard error of coefficients"; dia[1:k,.]'; dia[k+1:2*k,.]'; 

nu      = nobs-k;

/* Compute the log marginal data density for the VAR model 
*/ 

Phi=inv(x0'x0)*x0'y0; 
S=(y0-x0*Phi)'(y0-x0*Phi); 
i=1;  gamdum=0; gamt=0; 
do until i>nvar; 
gamdum=gamdum+lngam(0.5*(T0-k+1-i)); 
gamt=gamt+lngam(0.5*(T0+T1-k+1-i)); 
i=i+1; endo; 

lmdum=-nvar*(T0-k)*0.5*ln(pi)-(nvar/2)*ln(abs(det(x0'x0)))-(T0-k)*0.5*ln(abs(det(S)))+nvar*(nvar-1)*0.25*ln(pi)+gamdum;  /*dummy observation*/ 
lmdt=-nvar*(T0+T1-k)*0.5*ln(pi)-(nvar/2)*ln(abs(det(XX)))-(T0+T1-k)*0.5*ln(abs(det(nobs*SIG_hat)))+nvar*(nvar-1)*0.25*ln(pi)+gamt;  /*total observation*/ 


lmd=lmdt-lmdum; 

"Log-marginal Density" lmd; 
