/*filename:adftest.g 
** Description: Plotting raw series of output and hours worked 
** created : 02/09/05 
*/

library pgraph, user;
cls;

format /mat /on /mb1 /ros 16,8;


/* Global defaults
*/
  __output = 1;
  _fcmptol = 1E-10;

#include pathspec.g
#include dsgespec.g


/******************************************************** 
** Import data
** series (nobs,6)
*/

load path= ^datapath series[191,6]="megaseries.asc";
nobs  = rows(series);       /* number of observations          */
YY    = series[1:nobs,.];   

/********************************************************/

y1=YY[.,1]-YY[112,1]*ones(nobs,1); 
h1=YY[.,2]-meanc(YY[.,2])*ones(nobs,1); 
y2=YY[.,3]-YY[112,3]*ones(nobs,1);
h2=YY[.,4]-meanc(YY[.,4])*ones(nobs,1);
y3=YY[.,5]-YY[112,5]*ones(nobs,1);
h3=YY[.,6]-meanc(YY[.,6])*ones(nobs,1);

h1=100*h1;
h2=100*h2;
h3=100*h3;

nobs=rows(YY); 
ti= seqa(1954.5,0.25,nobs);

/* Plot Raw Series
*/
pltraw:   

   graphset;
   begwind;
   margin(0,0,0.2,0.2);
   window(1,1,0);
   fonts("microb");
   _ptitlht = 0.3;
   _paxht = 0.3;
   _pnumht = 0.25;
   _pcolor ={1 0 4} ;
   _pltype = {6 5 3};
   _protate = 0; 
   _plctrl = 0;
   _plwidth = 7.5;
   _psymsiz = 5;
   _plegstr = "Data Set 1\000Data Set 2\000Data Set 3";

   xtics(1955,2005,10,1);
   ytics(-15,15,5,1);
   title("Hours (% Deviations from Mean)");
   _plegctl = {2 3.5 3.5 4};
   xy(ti,h1~h2~h3);
 
   /* 
   nextwind;
   title("Output ");
   xy(ti,y1~y2~y3);
   */
   
   endwind;